/*       ___   ___   ___   ___
 *      /_  \ /   \ /  _\ /  _\
 *     // \_/// \_/_\ / \\  / \\
 *    //  _ //  _ / \\\_// /  //
 *    \\_/ \\\_/ \\ //  /  \_//
 *     \___/ \___/ \\__/ \___/
 *     Transferts srie pour Thomson
 *
 *  Oprations clavier RAW pour Unix
 *
 *  Copyright (C) 2015 Franois Mouret
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <unistd.h>
#include <termios.h>

static struct termios originalconsole;


void RawConsole(void) /*@globals errno@*/
{
    struct termios rawconsole ;

    /* Cre une console RAW */
    (void)tcgetattr(STDIN_FILENO, &originalconsole) ;
    rawconsole = originalconsole ;
    cfmakeraw(&rawconsole) ;
    (void)tcsetattr(STDIN_FILENO, TCSANOW, &rawconsole) ;
}


void
OriginalConsole(void) /*@globals errno@*/
{
    /* Rtablit la console d'origine */
    (void)tcsetattr(STDIN_FILENO, TCSANOW, &originalconsole) ;
}

/*
 * Le programme rcupre une frappe RAW au clavier
 */
char GetKeyboardHit(void) /*@globals errno,stdin@*/
{
    int c ;
    struct termios rawconsole ;

    /* Cre une console RAW */
    (void)tcgetattr(STDIN_FILENO, &originalconsole) ;
    rawconsole = originalconsole ;
    cfmakeraw(&rawconsole) ;
    (void)tcsetattr(STDIN_FILENO, TCSANOW, &rawconsole) ;

    /* Capture du caractre */
    do { c = getchar() ; } while ((c == (int)'\n') || (c == EOF)) ;

    /* Rtablit la console d'origine */
    (void)tcsetattr(STDIN_FILENO, TCSANOW, &originalconsole) ;

    /* Renvoie le caractre lu */
    return (char)c ;
}


