/*       ___   ___   ___   ___
 *      /_  \ /   \ /  _\ /  _\
 *     // \_/// \_/_\ / \\  / \\
 *    //  _ //  _ / \\\_// /  //
 *    \\_/ \\\_/ \\ //  /  \_//
 *     \___/ \___/ \\__/ \___/
 *     Transferts srie pour Thomson
 *
 *  Main pour un exemple de TOCOMM
 *
 *  Copyright (C) 2015 Puls
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifndef TRUE
#   define TRUE 1
#endif

#ifndef FALSE
#   define FALSE 0
#endif

extern int InputLine_Basic(char *) ;
extern int PrintInt_Basic(int) ;
extern int PrintLine_Basic(char *) ;
extern void SerialClose(void) ;
extern int SerialOpen(char *, int, int) ;

int main(int argc, char *argv[])
{
    char buffer[257] ;
    int bauds ;
    int datasize ;
    int number ;

    memset(buffer,0x00,257) ;

    if (argc >= 5)
    {
        bauds = atoi(argv[2]) ;
        datasize = atoi(argv[3]) ;

        if (SerialOpen(argv[1],bauds,datasize) == TRUE)
        {
            switch (toupper((int)argv[4][0]))
            {
                case 'P' :
                    /* Envoie une chane de caractres */
                    if (PrintLine_Basic(argv[5]) == FALSE)
                       (void)printf("Erreur PrintLine\n") ;
                    break ;
       
                case 'I' :
                    /* Envoie un nombre */
                    number = atoi(argv[5]) ;
                    if (PrintInt_Basic(number) == FALSE)
                       (void)printf("Erreur PrintInt\n") ;
                    break ;

                case 'S' :
                    /* Reoit une chane de caractres */
                    if (InputLine_Basic(buffer) == TRUE)
                        (void)printf("%s\n",buffer) ;
                    else (void)printf("Erreur InputLine\n") ;
                    break ;
             }
        }
        SerialClose() ;
    }
    return -1 ;
}
