/*       ___   ___   ___   ___
 *      /_  \ /   \ /  _\ /  _\
 *     // \_/// \_/_\ / \\  / \\
 *    //  _ //  _ / \\\_// /  //
 *    \\_/ \\\_/ \\ //  /  \_//
 *     \___/ \___/ \\__/ \___/
 *     Transferts série pour Thomson
 *
 *  Routines pour le Basic
 *
 *  Copyright (C) 2015 Puls
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef TRUE
#   define TRUE 1
#endif

#ifndef FALSE
#   define FALSE 0
#endif

#include <stdio.h>
#include <string.h>

extern int SerialWrite(char) ;
extern char SerialRead(void) ;


/*
 * Envoie une chaîne de caractères au Thomson
 */
int PrintLine_Basic(char *line)
{
    int i = 0 ;
    char c = '\0' ;
    char buffer[256] ;

    buffer[0] = '\0' ;
    strncat(buffer,line,255) ;
    buffer[(int)strlen(buffer)] = '\x0D' ;
    while (c != '\x0D')
    {
        c = buffer[i] ;
        switch (SerialWrite(c))
        {
            case 1 : i++ ; break ;
            case 0 : break ;
            default : return FALSE ;
        }
    }
    return TRUE ;
}


/*
 * Envoie un nombre au thomson
 */
int PrintInt_Basic(int number)
{
    char line[34] ;
    (void)snprintf(line,34,"%d",number) ;
    return (PrintLine_Basic(line)) ;
}


/*
 * Reçoit une chaîne de caractères du Thomson
 */
int InputLine_Basic(char *line)
{
    char c ;
    line[0] = '\0' ;
    do {
        switch ((c = SerialRead()))
        {
            case -1 :
                return FALSE ;
            case  0x00 :
            case  0x0D :
                break ;
            default :
                strncat(line,&c,1) ;
                break ;
        }
    } while(c != '\x0D') ;
    return TRUE ;
}

